# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION) < 6.30 ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have old versions of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)
%global older_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.94) ? 1 : 0);' 2>/dev/null || echo 0)
%global even_older_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)
%global ancient_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.82) ? 1 : 0);' 2>/dev/null || echo 0)

#TODO: BR: perl(Test::Pod::No404s) when available

Name:		perl-Test-Kwalitee
Version:	1.04
Release:	1.%{__distinit}%{__distvers}
Summary:	Test the Kwalitee of a distribution before you release it
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://metacpan.org/module/Test::Kwalitee
Source0:	http://cpan.metacpan.org/authors/id/E/ET/ETHER/Test-Kwalitee-%{version}.tar.gz
Patch0:		Test-Kwalitee-1.03-old-eumm.patch
Patch1:		Test-Kwalitee-1.03-subtests.patch
Patch2:		Test-Kwalitee-1.04-is_passing.patch
Patch3:		Test-Kwalitee-1.03-old-Test::More.patch
Patch4:		Test-Kwalitee-1.04-note.patch
Patch5:		Test-Kwalitee-1.03-spelling.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Build
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Module::CPANTS::Analyse) >= 0.87
BuildRequires:	perl(Test::Builder)
# Test Suite
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(Test::CheckDeps)
BuildRequires:	perl(Test::More) >= 0.47
# Release Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist::hanekomu)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes)
%endif
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Spelling) >= 0.12, aspell-en
BuildRequires:	perl(Test::Version)
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
Kwalitee is an automatically-measurable gauge of how good your software
is. That's very different from quality, which a computer really can't
measure in a general sense (if you can, you've solved a hard problem in
computer science).

%prep
%setup -q -n Test-Kwalitee-%{version}

# Remove use of subtests if we don't have Test::More ≥ 0.96
%if %{old_test_more}
%patch1
%endif

# Test::Builder->is_passing requires Test::More ≥ 0.94 (CPAN RT#84900)
%if %{older_test_more}
%patch2
%endif

# Test::More->done_testing requires Test::More ≥ 0.88
%if %{even_older_test_more}
%patch3
%endif

# Test::More->note requires Test::More ≥ 0.82
%if %{ancient_test_more}
%patch4
%endif

# Words that should be in the dictionary but aren't
%patch5

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test
%if 0%{!?perl_bootstrap:1}
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"
%else
make test TEST_FILES="$(echo $(find xt/ -name '*.t' | grep -Fv cpan-changes.t))"
%endif
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Kwalitee.3pm*

%changelog
* Sun Apr 28 2013 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - Re-release with bumped developer prereqs to depend on a higher version of
    Test::More for t/00-compile.t and t/00-check-deps.t (CPAN RT#84900)
- Update patches as needed

* Sat Apr 27 2013 Paul Howarth <paul@city-fan.org> - 1.03-1
- Update to 1.03
  - Fixed documentation to refer to the proper names of Kwalitee tests
    (CPAN RT#24506)
  - Cleaned up partially-botched distribution metadata and README
- Classify buildreqs by usage
- Add buildreqs for new tests
- Explicitly run extra tests unless bootstrapping
- Add several patches to support building with old versions of Test::More

* Mon Apr  1 2013 Paul Howarth <paul@city-fan.org> - 1.02-1
- Update to 1.02
  - No operational changes - re-releasing under new management via github and
    Dist::Zilla
- This release by ETHER -> update source URL
- Update upstream URLs to MetaCPAN
- Switch to ExtUtils::MakeMaker flow
- Package upstream's new LICENSE file
- Add patch to support building with ExtUtils::MakeMaker < 6.30

* Wed Jul 11 2012 Paul Howarth <paul@city-fan.org> - 1.01-13
- BR: perl(Test::More)
- Don't BR: perl(strict), perl(vars) or perl(warnings) - not dual-lived

* Thu Mar  8 2012 Paul Howarth <paul@city-fan.org> - 1.01-12
- BR: perl(Cwd), perl(strict), perl(Test::Builder), perl(vars), perl(warnings)
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to run tests with LC_ALL=C
  - Don't need to define %%{perl_vendorlib}

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> - 1.01-10
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 1.01-9
- Run tests with LC_ALL=C for Perl 5.8.0 compatibility
- Nobody else likes macros for commands

* Fri Mar 18 2011 Paul Howarth <paul@city-fan.org> - 1.01-8
- Import from Fedora

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 22 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.01-6
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu May 06 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.01-5
- Mass rebuild with perl-5.12.0

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 1.01-4
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb 14 2009 Allisson Azevedo <allisson@gmail.com> - 1.01-1
- Initial rpm release
